#include "soundtypes.h"

class Stream
{
	bool bit16;
	bool stereo;
	unsigned herz;
	
private:
	static unsigned read16(stent *dest, unsigned count);
	static unsigned readste(stent *dest, unsigned count);
	static unsigned read8(stent *dest, unsigned count);
	static void write16(const stent *src, unsigned count);
	static void writeste(const stent *src, unsigned count);
	static void write8(const stent *src, unsigned count);

	static const int inbufsize = 0x2000;
	static const int leapstep  = 0x1000;
	static const int newsize   = inbufsize-leapstep;
	
	int basepos; /* mit ei en saa takaisin */
	stent inent[inbufsize];
	
public:
	Stream(const char *settings);
	
	inline const unsigned rate() const { return herz; }
	
	const stent &operator[] (int index);
	inline void shift(int amount) { basepos -= amount; }
	
	unsigned Read(stent *dest, unsigned count) const;
    void Write(const stent *dest, unsigned count) const;
};
